﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GroupDataByOneField
{
    class Program
    {
        static void Main(string[] args)
        {
            List<Person> lst = new List<Person>();
            SqlCommand sqlCommand = new SqlCommand();

            try
            {
                sqlCommand.Connection = OpenDB();
                sqlCommand.CommandType = CommandType.Text;
                sqlCommand.CommandText = "SELECT * FROM PERSON";

                SqlDataReader reader = sqlCommand.ExecuteReader();

                if (reader.HasRows)
                {
                    while (reader.Read())
                    {
                        Person p = new Person();

                        p.IdReg = reader.GetInt32(0);
                        p.FirstName = reader.GetString(1);
                        p.LastName = reader.GetString(2);
                        p.Gender = reader.GetBoolean(3);
                        p.Country = reader.GetString(4);
                        p.Age = reader.GetInt32(5);
                        p.Date = reader.GetDateTime(6);
                        p.Id = reader.GetString(7);

                        lst.Add(p);

                    }
                }

                var query = lst.GroupBy(x => x.Country);

                foreach(var str in query)
                {
                    Console.WriteLine(str.Key);
                }
            
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message + " " + ex.StackTrace);
            }
            finally
            {
                sqlCommand.Connection.Close();
            }
            Console.WriteLine("Total de registros en la lista (Person): " + lst.Count);

        }

        static public SqlConnection OpenDB()
        {
            SqlConnection sqlConn = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnString"].ConnectionString);
            try
            {
                sqlConn.Open();
            }
            catch (SqlException ex)
            {
                throw new Exception(ex.Message, ex);
            }
            return sqlConn;
        }
    }
}
